#ifndef __OBJECT_H__
#define __OBJECT_H__

#include <iostream>

// INPUT OBJECT CLASSES

class Input
{
  public:
    virtual ~Input (void) {}

  public:
    virtual void print (void) const = 0;
};

class A : public Input
{
  public:
    virtual void print (void) const { std::cout << "A"; }
};

class B : public Input
{
  public:
    virtual void print (void) const { std::cout << "B"; }
};

// OUTPUT OBJECT CLASSES

class Output
{
  public:
    virtual ~Output (void) {}

  public:
    virtual void print (void) const = 0;
};

class C : public Output
{
  public:
    virtual void print (void) const { std::cout << "C"; }
};

class D : public Output
{
  public:
    virtual void print (void) const { std::cout << "D"; }
};

#endif
