#ifndef __DEBUGGER_H__
#define __DEBUGGER_H__

#include "operation.h"

#include <oors.h>

/**
 * Debugger for the simple pattern matcher.
 * Keeps track of each event and prints event information on stdout.
 */
class Debugger : public oors::Debugger<Operation, Operation>
{
  public:
    void currentRule (const oors::Rule<Operation, Operation> *rule);
    void finishRule (const oors::Rule<Operation, Operation> *rule, bool matched);
    void applyRule (const oors::Rule<Operation, Operation> *rule);
    void newAlternative (const oors::Alternative<Operation, Operation> *alternative, const oors::Alternative<Operation, Operation> *parent);
    void currentAlternative (const oors::Alternative<Operation, Operation> *alternative);
    void deleteAlternative (const oors::Alternative<Operation, Operation> *alternative);
    void checkItemPattern (const oors::Alternative<Operation, Operation> *alternative, unsigned int index, const Operation *item, bool result);
    void matchItemPattern (const oors::Alternative<Operation, Operation> *alternative, unsigned int index, const Operation *item);
    void matchWildcardPattern (const oors::Alternative<Operation, Operation> *alternative, unsigned int index, const Operation *item);
    void finishWildcardPattern (const oors::Alternative<Operation, Operation> *alternative, unsigned int index);
    void finishBasicBlock (int cost);
};

#endif
