#include "util.h"

std::string sanitize (const std::string &filename)
{
  // escape backslashes
  std::string result = filename;
  std::string::size_type pos = 0;
  while ((pos = result.find("\\", pos)) != std::string::npos)
  {
    result.replace (pos, 1, "\\\\");
    pos += 2;
  }

  // done
  return result;
}

std::string prefix (const std::string &filename)
{
  // remove last '.' only if it does not occur in front of any path seperator
  std::string::size_type slash = filename.find_last_of("/\\"), dot = filename.rfind('.');
  if (dot != std::string::npos && (slash == std::string::npos || slash < dot))
    return filename.substr (0, dot);

  // nothing to do
  return filename;
}

std::string extractName (const std::string &filename)
{
  // remove path information
  std::string::size_type pos = filename.find_last_of ("/\\");
  if (pos != std::string::npos)
    return filename.substr (pos+1, filename.length());

  // nothing to do
  return filename;
}

std::string extractPath (const std::string &filename)
{
  // remove path information
  std::string::size_type pos = filename.find_last_of ("/\\");
  if (pos != std::string::npos)
    return filename.substr (0, pos+1);

  // empty patch
  return "";
}
