#ifndef __UTIL_H__
#define __UTIL_H__

#include <string>

/**
 * Sanitize given filename.
 * Escapes each backslash.
 * @param filename The filename to sanitize.
 * @return Sanitized filename.
 */
std::string sanitize (const std::string &filename);

/**
 * Get file prefix.
 * Simply removes the file ending.
 * @param filename The filename to get the prefix of.
 * @return Filename prefix.
 */
std::string prefix (const std::string &filename);

/**
 * Extract filename by removing the path.
 * @param filename The filename to strip.
 * @return The pure filename.
 */
std::string extractName (const std::string &filename);

/**
 * Extract path by removing the filename.
 * @param filename The filename to strip.
 * @return The pure path.
 */
std::string extractPath (const std::string &filename);

#endif
