/**
 * exception.h
 * 2005-09-01
 */

#ifndef __EXCEPTION_H__
#define __EXCEPTION_H__

#include <string>

/**
 * Basic exception class.
 */
class Exception
{
  public:
    /**
     * Construct empty exception.
     */
    Exception (void)
    {
    }

    /**
     * Constructor.
     * @param msg Exception message.
     */
    Exception (const std::string &msg)
      : m_msg (msg)
    {
    }

  public:
    /**
     * Access exception message.
     * @return Exception message.
     */
    inline const std::string &msg (void) { return m_msg; }

  protected:
    /// exception message
    std::string m_msg;
};

/**
 * Input/Output exception.
 */
class IOException : public Exception
{
  public:
    /**
     * Constructor.
     * @param msg Exception message.
     */
    IOException (const std::string &msg)
      : Exception (msg)
    {
    }
};

#endif
